%{
#include "k.h" /* data type defs (incl. YYSTYPE) */
extern tree the_tree;  /* root of the parse tree */
%}

%token <yt_int>   T_INT
%token <yt_casestring>   T_NAME
%type  <yt_tree>  Y_tree
%type  <yt_bindings> Y_binds
%type  <yt_binding>  Y_bind
%type  <yt_expr>  Y_expr Y_term Y_factor

%%

Y_root:   Y_tree           { the_tree = $1; } ;

Y_tree:   Y_expr           { $$ = Tree( $1, Nilbindings() ); }
|   Y_expr ';' Y_binds     { $$ = Tree( $1, reverse_bindings( $3 )); }
;

Y_binds:  Y_bind           { $$ = Consbindings( $1, Nilbindings() ); }
|   Y_binds ';' Y_bind     { $$ = Consbindings( $3, $1 ); }
;

Y_bind: T_NAME '=' Y_expr  { $$ = Binding( $1, $3 ); } ;

Y_expr:   Y_term           { $$ = $1; }
|   Y_expr '+' Y_term      { $$ = Plus( $1, $3 ); }
;

Y_term:   Y_factor         { $$ = $1; }
|   Y_term '*' Y_factor    { $$ = Times( $1, $3 ); }
;

Y_factor:   T_INT          { $$ = Const( $1 ); }
|   T_NAME                 { $$ = Name( $1 ); }
|   '(' Y_expr ')'         { $$ = $2; }
;
