%{
#include "k.h" /* data type defs (incl. YYSTYPE) */
extern expr the_expr;  /* root of the parse tree */
%}

%token <yt_int>   T_INT
%type  <yt_expr>  Y_expr Y_term Y_factor

%%

Y_root:   Y_expr          { the_expr = $1; } ;

Y_expr:   Y_term          { $$ = $1; }
|   Y_expr '+' Y_term     { $$ = Plus( $1, $3 ); }
;

Y_term:   Y_factor        { $$ = $1; }
|   Y_term '*' Y_factor   { $$ = Times( $1, $3 ); }
;

Y_factor:   T_INT         { $$ = Const( $1 ); }
|   '(' Y_expr ')'        { $$ = $2; }
;
